/*

    Blacky's IPIP-Tunnel (Codierungs-Routinen)

    Copyright (c) Andreas Hofmeier

    Dieses Programm ermglicht es (wenn ntig, eine Verschlsselte)
    Verbindung zu einem Server zu erzeugen. ber die Verbindung kann
    man eine andere IP einnehmen (auch wenn man hinter einem Firewall
    oder Masquerading-Server sitzt).

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/



 */

#include <stdio.h>
#include "code.h"


encode(info, str, size)
  struct Code *info;
  char *str;
  int size;
{
  int i;

  for (i = 0; i < size; i++)
    {
      (info -> zeichen) = str[i];
      info -> code100++;
      if ((info -> code100) == (info -> code) - (info -> x000))
	{
	  (info -> code100) = 1;
	}
      (info -> codewwo)++;
      if ((info -> codewwo) > (info -> x000))
	{
	  (info -> codewwo) = 1;
	}
      (info -> zeichen) += (info -> code) + (info -> code100) + (info -> codewword)[(info -> codewwo) - 1] + (info -> lastcode);
      (info -> lastcode) = str[i];
      for (  ; ((info -> zeichen) < 0);  )
	{
	  (info -> zeichen) += 256;
	}
      for (  ; ((info -> zeichen) > 256);  )
	{
	  (info -> zeichen) -= 256;
	}
      str[i] = (char) (info -> zeichen);
    }
}


decode(info, str, size)
  struct Code *info;
  char *str;
  int size;
{
  int i;

  for (i = 0; i < size; i++)
    {
      info -> zeichen = str[i];
      info -> code100++;
      if ((info -> code100) == (info -> code) - (info -> x000))
	{
	  (info -> code100) = 1;
	}
      (info -> codewwo)++;
      if ((info -> codewwo) > (info -> x000))
	{
	  (info -> codewwo) = 1;
	}
      (info -> zeichen) += -(info -> code) - (info -> code100) - (info -> codewword)[(info -> codewwo) - 1] - (info -> lastcode);
      for (  ; ((info -> zeichen) < 0);  )
	{
	  (info -> zeichen) += 256;
	}
      for (  ; ((info -> zeichen) > 256);  )
	{
	  (info -> zeichen) -= 256;
	}
      str[i] = (info -> lastcode) = (char) (info -> zeichen);
    }
}



initcode(info, codeword, codewordprbyte, lastcodeinitbyte)
  struct Code *info;
  char *codeword;
  char codewordprbyte;
  char lastcodeinitbyte;
{
  strcpy(info -> codewword, codeword);
  info -> code100 = 0;
  info -> codewwo = 0;
  info -> code = codewordprbyte;

  for ((info -> i) = 0; (info -> i) <= (strlen(info -> codewword) - 1); (info -> i)++)
      {
	info -> i000 = info -> codewword[(info -> i)];
	info -> i000 += info -> code;
	if (info -> i000 > 256)
	   info -> i000 -= 256;
	info -> codewword[(info -> i)] = (char) info -> i000;
      }
  info -> x000 = strlen(info -> codewword);

  info -> i = 1;

  info -> lastcode = lastcodeinitbyte;
}


/*main(argc, argv)
  int argc;
  char *argv[];
{
  char cw[] = "Andreas Hofmeier";
  char pb = "x";
  char str[800000];
  int size;

  initcode(&en, cw, pb);
  initcode(&de, cw, pb);


  for (  ;  ;  )
    {
      size = read(fileno(stdin), str, 700000);
      if (size < 1)
	{
	  exit(0);
	}
      encode(&en, str, size);
      decode(&de, str, size);
      write(fileno(stdout), str, size);
    }
}*/
