/*
    Blacky's IPIP-Tunnel

    Copyright (c) Andreas Hofmeier

    Dieses Programm ermglicht es (wenn ntig, eine Verschlsselte)
    Verbindung zu einem Server zu erzeugen. ber die Verbindung kann
    man eine andere IP einnehmen (auch wenn man hinter einem Firewall
    oder Masquerading-Server sitzt).

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/types.h>
#include <signal.h>
#include <syslog.h>
#include <stdlib.h>

#include <errno.h>
#include <stdio.h>
#include <sys/types.h>


#include <netdb.h>
#include <arpa/inet.h>
#include <string.h>




#include "code.h"
#include "hofmeier.h"

// #define debug

/* function zum Herunterfahren ! */
static void finish(int sig);

char CONFIGFILE[] = "/blacky/vt/tnl.conf";
FILE *conf;

int ID_MAX_SIZE = 256;
int NAME_MAX_SIZE = 50;
int PWD_MAX_SIZE = 50;
int CMD_MAX_SIZE = 250;
int CONFIG_LINE_BUF_SIZE = 500;
int SCHLUESSEL_MAX_SIZE = 256;


char blacky_ver_info[] = "Blacky's Socket-TTY-Server v0.10 (c) Copyright 1999-2001 Andreas Hofmeier";


int fd, out, in, hp, hp2;
char ptydev[20], ttydev[20];
int i;
#define BUFFSIZE 3000000
char s[BUFFSIZE];


/* Prft anhant der Config-Datei die Identitt des Users, und Ld
   infos (Schlssel etc.)*/
iflogin(name, pwd, cmd)
  char *name, *pwd, *cmd;
{

  char cd[CONFIG_LINE_BUF_SIZE];
  int namelen = strlen(name);

  for (  ;  ;  ) {
    /* Lesen einer Zeile (eines Datensatzes) */
    fgets(cd, CONFIG_LINE_BUF_SIZE, conf);

    /* Passt das LogIn name ? */
    if (strncmp(name, cd, namelen) == 0) {
      int pwdlen = strlen(pwd);
      /* Ist das Passwort OK? */
      if (strncmp(pwd, cd + namelen + 1, pwdlen) == 0) {
	unsigned char prbyte, verbyte;
	char bb[10];
	char schluessel[SCHLUESSEL_MAX_SIZE];

	/* Login OK */
	/* Auslesen der Daten */
	/* Rest der Zeile */
	int i = namelen + 1 + pwdlen + 1;
	char *info = cd + i;
	/* Schlssel */
	for (i = 0; (!((info[i] == '|') || (info[i] == 0))); i++) {
	  schluessel[i] = info[i];
	}
	schluessel[i] = 0;
	/* PR-Byte */
	info += (i + 1);
	for (i = 0; (!((info[i] == '|') || (info[i] == 0))); i++) {
	  bb[i] = info[i];
	}
	bb[i] = 0;
	prbyte = (unsigned char) atoi(bb);
	/* Ver-Byte */
	info += (i + 1);
	for (i = 0; (!((info[i] == '|') || (info[i] == 0))); i++) {
	  bb[i] = info[i];
	}
	bb[i] = 0;
	verbyte = (unsigned char) atoi(bb);
	/* Command */
	info += (i + 1);
	for (i = 0; (!((info[i] == '|') || (info[i] == 0))); i++) {
	  cmd[i] = info[i];
	}
	cmd[i] = 0;
	/* Init-Code... */
	initcode(&en, schluessel, prbyte, verbyte);
	initcode(&de, schluessel, prbyte, verbyte);
	syslog(LOG_INFO, "LogIn: %s", name);
	/* OK */
	return 0;
      }
    }
    if (feof(conf) != 0) {
      /* Dateiende erreicht, kein gltiger eintrag, EXIT */
      syslog(LOG_INFO, "** ERROR: LogIn Failt!: %s:%s", name, pwd);
      exit(1);
    }
  }
}



main(argc, argv)
  int argc;
  char *argv[];
{
  /* ID */
  char ID[ID_MAX_SIZE];
  char ID2[ID_MAX_SIZE];
  /* Name */
  char name[NAME_MAX_SIZE];
  /* User-Passwort */ 
  char pwd[NAME_MAX_SIZE];
  /* Commando fr den pppd */
  char cmd[CMD_MAX_SIZE];
  /* Verschlsseln? */
  char verschluesseln[5];

  /* LOG-File ffnen */
  openlog("tnl", LOG_CONS || LOG_NDELAY, LOG_AUTHPRIV);
  {
    int                     sp = fileno(stdin);   /*  Socket pointer */
    struct sockaddr_in      cs;                   /*  Communication parameters */
    int                     len;
    char                    *ip, *name;
    struct hostent          *ch_again;
    len = sizeof(cs);

    if (getpeername(sp,(struct sockaddr *)&cs,&len) < 0){
      syslog(LOG_INFO, "connected: ** ERROR: Can't get socketdata: getpeername()");
    } else {
      ip = (char *) strdup(inet_ntoa(cs.sin_addr));
      ch_again = gethostbyname(ip);
      syslog(LOG_INFO, "connected: %s\n(%s)\n", ip, strdup(ch_again->h_name));
    }
  }
  /* ffnen des Config-Files... */

  if ((conf = fopen(CONFIGFILE, "r")) == NULL) {
    syslog(LOG_INFO, "** ERROR: Configurations-Datei konnte nicht geffnet werden: %s\n", CONFIGFILE);
    perror(CONFIGFILE);
    exit(1);
  }
  /* Lesen der ID */
  fgets(ID, ID_MAX_SIZE, conf);
  fgets(ID2, ID_MAX_SIZE, stdin);
  /* Wurde die ID richtig bertragen? Wenn nicht EXIT */
  if (strcmp(ID, ID2) != 0) {
    exit(1);
  }
  /* Lesen der LOGIN daten ... */
  /* Name */
  gets(name);
  /* PassWD */
  gets(pwd);
  /* Ist das LOGIN OK? */
  iflogin(name, pwd, cmd);
  /* verschluesseln? */
  gets(verschluesseln);
  
  /* ############# OPEN TTY ############# */
  if ((fd = blacky_gettty(ttydev, ptydev)) < 0) {
    syslog(LOG_INFO, "** ERROR: Configurations-Datei konnte nicht geffnet werden: %s\n", CONFIGFILE);
    //      fprintf(stderr, "** FEHLER: Konnte keinen TTY ffnen! (Dieses Programm mu unter root laufen)!\n");
    exit(1);
  }
  /* ############# OPEN Socket ############# */
  in = fileno(stdin);
  out = fileno(stdout);

  /* Interrups vergeben ... */
  signal(SIGHUP, finish);       /* 01  /  hangup     - Alt-F4                            */
  signal(SIGINT, finish);       /* 02  /  Interrupt  - ^C                                */
  signal(SIGQUIT, finish);      /* 03  /  Quit                                           */
  signal(SIGTERM, finish);      /* 15  /  Terminierung                                   */

  /* #############  Umlenkung  ############# */
  /* Im Hintergrund */
  if (!(hp = fork())) {
    s[0] = 0;
#ifdef debug
    syslog(LOG_INFO, "ts_ start fork %d\n", hp);
#endif
    if (verschluesseln[0] == '0') {
      /* Es wird _NICHT_ Verschlsselt */
      for (  ;  ;  ) {
	if ((i = read(fd, s, BUFFSIZE)) < 0) {
	  usleep(10);
	  if (s[0] != 0) {
  	    exit(0);
	  }
	}
	write(out, s, i);
	fflush(stdout);
      }
    } else	{
      /* Versclsseln */
      for (  ;  ;  ) {
	if ((i = read(fd, s, BUFFSIZE)) < 0) {
	  usleep(10);
	  if (s[0] != 0) {
  	    exit(0);
	  }
	}
	encode(&en, s, i);
	write(out, s, i);
	fflush(stdout);
      }
    }
  }
  if (!(hp2 = fork())) {
#ifdef debug
    syslog(LOG_INFO, "ts_ start fork %d\n", hp2);
#endif
    if (verschluesseln[0] == '0') {
      /* Es wird _NICHT_ Verschlsselt */
      for (  ;  ;  ) {
	i = read(in, s, BUFFSIZE);
	if (i </*=*/ 0)
	  {
	    sprintf(s, "kill $(ps axwww | grep %s | awk \'{print $1}\')  2> /dev/null &", ttydev);
	    system(s);
	    
	    kill(getppid(), 15);
	    sleep(2);
	    kill(getppid(), 9);
#ifdef debug
	    syslog(LOG_INFO, "ts_ fehler beim lesen, kille Programm: %s\n", s);
#endif
	    exit(0);
	  }
	write(fd, s, i);
      }
    } else {
      /* Versclsseln */
      for (  ;  ;  ) {
	i = read(in, s, BUFFSIZE);
	if (i <= 0) {
	  sprintf(s, "kill $(ps axwww | grep %s | awk \'{print $1}\') 2> /dev/null &", ttydev);
	  system(s);

	  kill(getppid(), 15);
	  sleep(2);
	  kill(getppid(), 9);
#ifdef debug
	  syslog(LOG_INFO, "ts_ fehler beim lesen (endschlsseln), kille Programm: %s\n", s);
#endif
	  exit(0);
	}
	decode(&en, s, i);
	write(fd, s, i);
      }
    }
  }
  /* Startte Programm... */
  sprintf(s, cmd, ttydev);
#ifdef debug
  syslog(LOG_INFO, "ts_ starte Programm: %s\n", s);
#endif
  system(s);
#ifdef debug
  syslog(LOG_INFO, "ts_ Programm bendet: %s\n", s);
#endif
  /* Wenn Programm beendet ist, sich selbst killen... */
  sleep(5);
  kill(hp, 15);
  kill(hp2, 15);
  sleep(1);
  kill(hp, 9);
  kill(hp2, 9);
#ifdef debug
  syslog(LOG_INFO, "ts_ exit main: %s\n", s);
#endif


  exit(0);
}


static void finish(int sig)
{
#ifdef debug
  syslog(LOG_INFO, "ts_ empfing signal: %d\n", sig);
#endif

  /* Interrups neu vergeben ... */
  signal(SIGHUP, finish);       /* 01  /  hangup     - Alt-F4                            */
  signal(SIGINT, finish);       /* 02  /  Interrupt  - ^C                                */
  signal(SIGQUIT, finish);      /* 03  /  Quit                                           */
  signal(SIGTERM, finish);      /* 15  /  Terminierung                                   */

  sprintf(s, "kill $(ps axwww | grep %s | awk \'{print $1}\') 2> /dev/null", ttydev);
#ifdef debug
  syslog(LOG_INFO, "ts_ kille Programm: %s\n", s);
#endif
  system(s);
  /* Wenn Programm beendet ist, sich selbst killen... */
  sleep(5);
  kill(hp, 15);
  kill(hp2, 15);
  sleep(5);
  kill(hp, 9);
  kill(hp2, 9);
#ifdef debug
  syslog(LOG_INFO, "ts_ exit finish\n", s);
#endif

  exit(0);
}
