/*
    Blacky's IPIP-Tunnel

    Copyright (c) Andreas Hofmeier

    Dieses Programm ermglicht es (wenn ntig, eine Verschlsselte)
    Verbindung zu einem Server zu erzeugen. ber die Verbindung kann
    man eine andere IP einnehmen (auch wenn man hinter einem Firewall
    oder Masquerading-Server sitzt).

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <varargs.h>
#include <sys/socket.h>
#include <signal.h>

#include "code.h"
#include "hofmeier.h"


/* function zum Herunterfahren ! */
static void finish(int sig);


// Diese Zeile nochmal in tunnel.c kopieren, damit es get_internet auch schnallt!
char blacky_ver_info[] = "Blacky's Socket-TTY v0.20 (c) Copyright 1999-2002 Andreas Hofmeier";


int hp, hp2, fd, sock;
char ptydev[20], ttydev[20];
int i;
#define BUFFSIZE 3000000
int BUFFSIZE_MODEM = BUFFSIZE;
FILE *modem;


char s[BUFFSIZE];


main(argc, argv)
  int argc;
  char *argv[];
{
  char help = 0;

  if (argc < 7) {
    help = 1;
  }
  if (argc > 7) {
    if ((!((argv[7][0] == '-') && (argv[7][1] == 'e') && (argv[7][2] == 0))) || (argc != 11)) {
      help = 1;
    }
  }

  if (help == 1) {
    printf(
"/blacky/vt/tnl <Server> <port> <ID> <Name> <PWD> <\"command\"> -e <schssel> <PRByte> <VerByte>\n\n"

"<Server>:      Name oder IP des Servers\n"
"<Port>:        Port, hinter welchem der tnl.svr sitzt, (2005)\n"
"<ID>:          Hat keine Relevans, es mu aber irgentwas bergeben werden\n"
"<Name>:        Login-Name\n"
"<PWD>:         Passwort fr das Account\n"
"<\"command\">:   Commandozeile: Mit ``\"/usr/sbin/pppd %%s\"'' mte\n"
"               gehen. Das ``%%s'' steht auch hier wieder fr das\n"
"               Pseudo-TTY-Device und kann nur einmal benutzt werden.\n"
"-e:            Hiermit wird die Verschlsselung aktivirt, die Verschlsselung\n"
"                 mu aktivirt werden!\n"
" <schssel>:   Schlssel\n"
" <PRByte>:     Ein Weiterer Schlssel\n"
" <VerByte>:    Ein Weiterer Schlssel\n"
);
    exit(0);
  }


  /* Interrups vergeben ... */
  signal(SIGHUP, finish);       /* 01  /  hangup     - Alt-F4                            */
  signal(SIGINT, finish);       /* 02  /  Interrupt  - ^C                                */
  signal(SIGQUIT, finish);      /* 03  /  Quit                                           */
  signal(SIGTERM, finish);      /* 15  /  Terminierung                                   */

  /* ############# OPEN TTY ############# */
  if ((fd = blacky_gettty(ttydev, ptydev)) < 0) {
    fprintf(stderr, "** FEHLER: Konnte keinen TTY ffnen! (Dieses Programm mu unter root laufen)!\n");
    exit(1);
  }
/* ############# OPEN Socket ############# */
  if (strcasecmp(argv[2], "modem") == 0) {
    char s[512];
    //    FILE *modem;
    if ((modem = fopen(argv[1], "r+")) == NULL) {
      perror(argv[1]);
      exit(1);
    }
    fprintf(modem, "AT S7=45 S0=0 L1 V1 X4 &c1 E1 Q0%c\n", 13);
    ffsync(modem);
    BUFFSIZE_MODEM = 64;
    sock = fileno(modem);
    while (1) {
      fgets(s, BUFFSIZE, modem);
      if (strncasecmp(s, "ring", 4) == 0) {
	fprintf(modem, "ATA%c\n", 13);
	ffsync(modem);
      }
      if (strncasecmp(s, "connect", 7) == 0) {
	break;
      }
    }
  } else {
    sock = Socket(argv[1], atoi(argv[2]));
    if (sock < 1) {
      fprintf(stderr, "** FEHLER: Konnte die Socket-Stream-Verbindung nicht erzeugen...\n");
      exit(1);
    }
  }

  /* Protokoll? */ 
  {
    char cd[255];
    SockRecvString(sock, cd);
    if (strcmp(cd, "tnl1") != 0) {
      fprintf(stderr, "Protokoll error! Port 2005?\n");
      exit(1);
    }
  }
  /* LoginName senden */
  SockSendString(sock, argv[4]);
  /* PassWD - Prfen ob Gegenseite die ist fr die sie sich ausgiebt */
  if (SockMD5Auth(sock, argv[5]) != 1) {
    fprintf(stderr, "Error whiling login: Login denied\n");
    exit(1);
  }
  /* Verschlsselung */
  /* Init-Code... */
  initcode(&en, argv[8], (unsigned char) atoi(argv[9]), (unsigned char) atoi(argv[10]));
  initcode(&de, argv[8], (unsigned char) atoi(argv[9]), (unsigned char) atoi(argv[10]));      
  /* Im Hintergrund */
  if (!(hp = fork())) {
    s[0] = 0;
    /* Verschlsselt */
    for (  ;  ;  ) {
      if ((i = read(fd, s, BUFFSIZE)) <= 0) {
	usleep(10);
	if (s[0] != 0) {
	  exit(0);
	}
      }
      encode(&en, s, i);
      write(sock, s, i);
    }
  }
  if (!(hp2 = fork())) {
    /* Verschlsselt */
    for (  ;  ;  ) {
      i = read(sock, s, BUFFSIZE_MODEM);
      if (i </*=*/ 0) {
	kill(hp, 15);
	kill(getppid(), 15);
	
	sprintf(s, "kill $(ps axwww | grep %s | awk \'{print $1}\') 2> /dev/null", ttydev);
	system(s);
	sprintf(s, "sleep 30; kill $(ps axwww | grep %s | awk \'{print $1}\') 2> /dev/null &", ttydev);
	system(s);
	exit(0);
      }
      decode(&de, s, i);
      write(fd, s, i);
    }
  }

  /* Starte Programm... */
  sprintf(s, argv[6], ttydev);
  system(s);
  /*Kind-Killen*/
  sleep(5);
  kill(hp, 15);
  kill(hp2, 15);
  sleep(5);
  kill(hp, 9);
  kill(hp2, 9);

  exit(0);
}


static void finish(int sig)
{
  sprintf(s, "kill $(ps axwww | grep %s | awk \'{print $1}\') 2> /dev/null", ttydev);
  system(s);
  sprintf(s, "sleep 30; kill $(ps axwww | grep %s | awk \'{print $1}\')  2> /dev/null &", ttydev);
  system(s);
  /* Wenn Programm beendet ist, sich selbst killen... */
  sleep(1);
  kill(hp, 15);
  kill(hp2, 15);
  sleep(5);
  kill(hp, 9);
  kill(hp2, 9);
  exit(0);
}
